unit code;

{This file contains all the declarations necessary for a pascal definition of a function that will be}
{installed in proFit's function menu.}

{This pascal unit uses another unit, called proFitDefinitions, that contains all the constants and type definitions}
{needed. If your pascal compiler does not allow the use of separate units you must merge the two files}
{see the proFit user manual for further details}

{ To add a function to proFit's func menu, proceed as follows:									}

{	complete this unit with your code.}
{	For a commented example see the file ErrorFunc.p }

{    compile this unit with your compiler  tell your compiler to save it as a CODE resource. 		}

{    Add it to proFit using the External Modules...   commmand.				}

{ IMPORTANT NOTE: }
{ The special way in which global variables are treated in Macintosh compilers makes it 			}
{ impossible to use global variables in spearated code segments. This means that you  			}
{ MUST NOT define any varibales outside your procedures! }

{ please see the proFit User Manual for further details }

interface

	uses
		proFitDefinitions;


	procedure main (var name: str20;				{ the name of the function }
									var descr: descrType;			{ a description of the function for the parameters window }
									var firstPtr: ptr;					{ pointer to the procedure 'first' or nil if not used }
									var checkPtr: ptr;					{ pointer to the procedure 'check' or nil if not used }
									var funcPtr: ptr;					{ pointer to the procedure 'func' or nil if not used }
									var derivativesPtr: ptr;			{ pointer to the procedure 'derivatives' or nil if not used }
									var freeUserMPtr: ptr; 			{ pointer to the procedure 'FreeUserMemory' or nil if not used }
									var nrParams: integer;			{ the number of parameters the function will use (  maxNrParams ) }
									var a: paramArray;			{ the default values  for the parameters }
									var mode: paramModesArray;	{ the default  modes for the parameters }
									var aName: paramNamesArray; 		{ the parameter names }
									InfPtr: globalsPtrT);				{ pointer to a record containing global variables and some proFit globals available to the user }

implementation


{ this is the function that proFit will use when fitting, plotting, etc .. }
	procedure func (var x: extended; var a: paramArray; var y: extended; InfPtr: globalsPtrT);
	begin
	end;

	procedure derivatives (var x: extended; var a: paramArray; var dyda: paramArray; InfPtr: globalsPtrT);
	begin
	end; { derivatives }

	function Check (ParamNr: integer; var a: paramArray; var mode: ParamModesArray; var aName: ParamNamesArray; InfPtr: GlobalsPtrT): CheckPAnswer;
	begin
		Check := ok;
	end;

	procedure first (var a: paramArray; InfPtr: globalsPtrT);
	begin
	end;

	procedure freeUserMemory (InfPtr: globalsPtrT);
	begin
	end;

	procedure main (var name: str20;				{ the name of the function }
									var descr: descrType;			{ a description of the function for the parameters window }
									var firstPtr: ptr;					{ pointer to the procedure 'first' or nil if not used }
									var checkPtr: ptr;					{ pointer to the procedure 'check' or nil if not used }
									var funcPtr: ptr;					{ pointer to the procedure 'func' or nil if not used }
									var derivativesPtr: ptr;			{ pointer to the procedure 'derivatives' or nil if not used }
									var freeUserMPtr: ptr; 			{ pointer to the procedure 'FreeUserMemory' or nil if not used }
									var nrParams: integer;			{ the number of parameters the function will use (  maxNrParams ) }
									var a: paramArray;			{ the default values  for the parameters }
									var mode: paramModesArray;	{ the default  modes for the parameters }
									var aName: paramNamesArray; 		{ the parameter names }
									InfPtr: globalsPtrT);				{ pointer to a record containing global variables and some proFit globals available to the user }
	begin
		name := 'name';
		descr[1] := 'description string 1';
		descr[2] := 'description string 2';
		firstPtr := nil;{ if it were implemented, we would have written firstPtr := @first;}
		checkPtr := nil;
		funcPtr := @func;
		freeUserMPtr := nil;
		derivativesPtr := nil;
		nrParams := 1;
		a[1] := 0;
		mode[1] := inactive;
		aName[1] := 'a';
	end;  { main }


end.