#include "proFit_definitions.h"

/**************************  functions called by proFit *******************************/
/****** the definitions for the following functions must be provided by you  **********/

pascal void func (double* x, paramArray a, double* y,globalsPtrT InfPtr);

pascal void derivatives(double* x, paramArray a, paramArray dyda,globalsPtrT InfPtr);

pascal char check(short ParamNr, paramArray a, paramModesArray mode, paramNamesArray aName, globalsPtrT InfPtr);

pascal void first (paramArray a,globalsPtrT InfPtr);

pascal void freeUserMemory (globalsPtrT InfPtr );
	
pascal void  main (	str20 name,			//the name of the function 
					descrType descr,	// a description of the function for the parameters window
					pascal void (**firstPtr)(paramArray, globalsPtrT),
								// pointer to the procedure 'first' or nil if not used
					pascal char (**checkPtr)(short, paramArray, paramModesArray, paramNamesArray, globalsPtrT) ,
								// pointer to the procedure 'check' or nil if not used
					pascal void (**funcPtr)(double*, paramArray, double*, globalsPtrT) ,
					 			// pointer to the procedure 'func' or nil if not used
					pascal void (**derivativesPtr)(double*, paramArray, paramArray, globalsPtrT) ,
					 			// pointer to the procedure 'derivatives' or nil if not used 
					pascal void (**freeUserMPtr)(globalsPtrT) ,
					  			// pointer to the procedure 'FreeUserMemory' or nil if not used
					short* nrParams,			// the number of parameters the function will use (  maxNrParams ) 
					paramArray a,			// the default values  for the parameters
					paramModesArray mode,	// the default  modes for the parameters
					paramNamesArray aName, 	// the parameter names
					globalsPtrT InfPtr);	// pointer to a struct containing some proFit globals available to you
/***************************************************************************************/
