unit code;

{This file contains all the declarations necessary for a pascal definition of a program that will be}
{installed in proFit's function menu.}

{This pascal unit uses another unit, called proFitDefinitions, that contains all the constants and type definitions}
{needed. If your pascal compiler does not allow the use of separate units you must merge the two files}
{see the proFit user manual for further details}

{ To add a program to proFit's Calc menu, proceed as follows:									}

{	complete this unit with your code.}
{	For a commented example see the file Multiply.p }

{    compile this unit with your compiler  tell your compiler to save it as a CODE resource. 		}

{    Add it to proFit using the External Modules...   commmand.				}

{ IMPORTANT NOTE: }
{ The special way in which global variables are treated in Macintosh compilers makes it 			}
{ impossible to use global variables in spearated code segments. This means that you  			}
{ MUST NOT define any varibales outside your procedures! }

{ please see the proFit User Manual for further details }

interface

	uses
		proFitDefinitions;


	procedure main (var name: str20;			{ the name of the function }
									var runPtr: ptr;				{ pointer to the procedure 'run' or nil if not used }
									var freeUserMPtr: ptr; 		{ pointer to the procedure 'freeUserMemory' or nil if not used }
									InfPtr: GlobalsPtrT);			{ pointer to a record containing global variables and some proFit globals available to the user }

implementation

	procedure run (InfPtr: globalsPtrT);
	begin
	end;

	procedure freeUserMemory (InfPtr: globalsPtrT);
	begin
	end;


	procedure main (var name: str20;			{ the name of the function }
									var runPtr: ptr;				{ pointer to the procedure 'run' (must not be nil) }
									var freeUserMPtr: ptr; 		{ pointer to the procedure 'freeUserMemory' or nil if not used }
									InfPtr: globalsPtrT);			{ pointer to a record containing global variables and some proFit globals available to the user }
	begin
		name := 'name';
		runPtr := @Run;
		freeUserMPtr := nil;		{ we didn't make any global data in a handle ! }
	end;  { main }

end.